#include "main.h"
#include "MDR32F9Qx_port.h"
#include "MDR32F9Qx_rst_clk.h"

#include "button.h"
#include "itmr.h"
#include "led.h"
#include "misc.h"
#include "uart.h"

#include "buzzer.h"

/*
	  ,      (   )
*/

static unsigned char StateButton; //    
static unsigned int PrevState = NOPRESS_B, //   
					StartInt; //    
static char FMode = 0;

#define INT_DELAY	5 //     
enum{
	BUTTON_NO_PRESS, //    
	BUTTON_DELAY	 // ""   
};

//------------------------------------------------------------
void button_Init(void)
{
	PORT_InitTypeDef PORT_InitStructure;
	
	RST_CLK_PCLKcmd(RST_CLK_PCLK_PORTA | RST_CLK_PCLK_PORTB, ENABLE);			
	
	PORT_InitStructure.PORT_OE = PORT_OE_IN;
	PORT_InitStructure.PORT_FUNC = PORT_FUNC_PORT;
	PORT_InitStructure.PORT_MODE = PORT_MODE_DIGITAL;
	PORT_InitStructure.PORT_SPEED = PORT_SPEED_SLOW;
	
	PORT_InitStructure.PORT_Pin = (PORT_Pin_3 | PORT_Pin_8 | PORT_Pin_9 | PORT_Pin_11);	
	PORT_Init(MDR_PORTB, &PORT_InitStructure);	
	
	PORT_InitStructure.PORT_OE = PORT_OE_IN;
	PORT_InitStructure.PORT_FUNC = PORT_FUNC_PORT;
	PORT_InitStructure.PORT_MODE = PORT_MODE_DIGITAL;
	PORT_InitStructure.PORT_SPEED = PORT_SPEED_SLOW;
	
	PORT_InitStructure.PORT_Pin = (PORT_Pin_8);	
	PORT_Init(MDR_PORTA, &PORT_InitStructure);	
}

//------------------------------------------------------------
//   
//    
unsigned short button_Press(void)
{		
	unsigned short cur_state = (((PORT_ReadInputData(MDR_PORTB) & NOPRESS_B)>>3) + ((PORT_ReadInputData(MDR_PORTA) & NOPRESS_A) << 1));			
	
	switch(StateButton){
		case BUTTON_NO_PRESS:			
			if(cur_state != PrevState){
				StateButton = BUTTON_DELAY;
				StartInt = itmr_GetTick();
				return NOPRESS;
			}
			else
				if(FMode && cur_state != NOPRESS){
					StateButton = BUTTON_DELAY;
					StartInt = itmr_GetTick();
					return NOPRESS; 
				}
				else
					return NOPRESS;			
		
		case BUTTON_DELAY:			
			if(itmr_IsTime(StartInt, INT_DELAY)){				
				if(cur_state != PrevState){
					StateButton = BUTTON_NO_PRESS;
					PrevState = cur_state;										
					return PrevState;
				}
				else{					
					if(FMode && cur_state != NOPRESS){						
						StateButton = BUTTON_NO_PRESS;
						return cur_state;
					}
					else{
						StateButton = BUTTON_NO_PRESS;
						return NOPRESS;
					}
				}
			}				
			else{
				StateButton = BUTTON_DELAY;
				return NOPRESS;
			}
		
		default:
			return NOPRESS;						
	}		
}

//------------------------------------------------------------
void button_SetFastMode(char fmode)
{
	FMode = fmode;
}

void button_Test(void)
{/*
	switch(button_Press()){
		case UP:
			led_Write(4, true);
			//buzzer_On(1000);
			break;
		case DOWN:
			led_Write(5, true);
			//buzzer_On(500);
			break;
		case LEFT:
			led_Write(6, true);
			//buzzer_On(100);
			break;
		case RIGHT:
			led_Write(7, true);
			//buzzer_On(200);
			break;
		case SELECT:			
			led_Write(4, false);
			led_Write(5, false);
			led_Write(6, false);
			led_Write(7, false);	
			break;		
		default:		
			break;
	}
	*/
		unsigned short cur_state = (((PORT_ReadInputData(MDR_PORTB) & NOPRESS_B)>>3) + ((PORT_ReadInputData(MDR_PORTA) & NOPRESS_A) << 1));			
		char buffer[32];
	sprintf(buffer, "%x \r\n> ", cur_state);
		uart_SendBuf(buffer,23);
	/*
	if(PORT_ReadInputData(MDR_PORTC) & NOPRESS_C) led_Write(6, false);	
	else led_Write(6, true);
	*/
	
}
