#include <string.h>
#include <stdio.h>
#include <stdlib.h>


#include "MDR32F9Qx_uart.h"

#include "led.h"
#include "button.h"

#include "itmr.h"

#include "encoder.h"
#include "uart.h"
#include "terminal.h"
#include "buzzer.h"
#include "disp.h"
#include "rtc.h"
#include "console.h"
#include "wnds.h"
#include "intro.h"
#include "mcp23s18.h"
#include "MDR32F9Qx_timer.h"
#include "mouse.h"
#include "keyboard.h"
#include "adc.h"
#include "dac.h"
#include "rs485.h"
#include "can.h"
#include "wdt.h"
#include "MDR32F9Qx_iwdg.h"
#include "MDR32F9Qx_dma.h"
#include "eth.h"
#include "eth_drv.h"
#include "main.h"
#include "system_MDR1986BE4.h"

#include "MDR32F9Qx_port.h"
#include "hy28b_drv.h"

#include "adc.h"

extern char wnd_choose = 3;	//2

extern DMA_ChannelInitTypeDef DMA_InitStr;
extern DMA_CtrlDataInitTypeDef DMA_PriCtrlStr;
extern DMA_CtrlDataInitTypeDef DMA_AltCtrlStr;

void TIMER1_IRQHandler(void)
{				
	if(TIMER_GetITStatus(MDR_TIMER1, TIMER_STATUS_CCR_CAP_CH1) == SET){
		TIMER_ClearFlag(MDR_TIMER1, TIMER_STATUS_CCR_CAP_CH1);		
		if (wnd_choose == 1)
		{
		  encoder_IRQProc();	
			led_Toggle(6);			
		}
		if (wnd_choose == 2)
		{
			mouse_IRQProc();
			
		}
		if (wnd_choose == 3)
		{
			keyboard_IRQProc();		
			led_Toggle(6);
		}
	}	
}

void DMA_IRQHandler(void)
{NVIC_DisableIRQ(DMA_IRQn);
  /* Reconfigure the inactive DMA data structure*/
  if((MDR_DMA->CHNL_PRI_ALT_SET & (1<<DMA_Channel_ADC)) == (0<<DMA_Channel_ADC))
  {
    DMA_AltCtrlStr.DMA_CycleSize = 10;
    DMA_Init(DMA_Channel_ADC, &DMA_InitStr);
  }
  else if((MDR_DMA->CHNL_PRI_ALT_SET & (1<<DMA_Channel_ADC)) == (1<<DMA_Channel_ADC))
  {
    DMA_PriCtrlStr.DMA_CycleSize = 10;
    DMA_Init(DMA_Channel_ADC, &DMA_InitStr);
  }
}


int main(void)
{ unsigned int stime;
	SystemInit();
	
	itmr_Init();	
	
	led_Init();
	button_Init();	
	
// rs485 and can initializations are in wnd_rs485test and wnd_cantest? because PORTC PIN_2
// makes ADC unworkable, I dont know why!
	
	uart_Init(115200, UART_WordLength8b, UART_StopBits1, UART_Parity_No);	
	terminal_Init();
	keyboard_Init();
	mcp23s18_Init();	
	
	//ethernet_LowLevelInit();
	
	disp_Init();	
  intro_Init();

	adc_Init();
	dac_Init();
	
	buzzer_Init();
	console_Init();
	wnd_Main();

	rtc_Init();

	wdt_Init();
	
  while(1){		
	
		led_Work();
	
		console_Work();
		terminal_Work();
		
	//	eth_FrameProcessing();
	
		buzzer_Work();
		
		wdt_ReLoad();
	
		
  }
	
}
