#include "MDR32F9Qx_port.h"
#include "MDR32F9Qx_rst_clk.h"
#include "itmr.h"
#include "rs485.h"

static unsigned int TestTimer;
#define TEST_PERIOD	5000


//   
void rs485_TransmitterCtrl(char ctrl)
{
	PORT_WriteBit(MDR_PORTC, PORT_Pin_3, ctrl ? Bit_SET : Bit_RESET);		//RW
}

void rs485_Init(void)
{
	PORT_InitTypeDef PORT_InitStructure;		
	//  D
	RST_CLK_PCLKcmd(RST_CLK_PCLK_PORTC, ENABLE);	
	
	PORT_InitStructure.PORT_FUNC = PORT_FUNC_PORT;
	PORT_InitStructure.PORT_MODE = PORT_MODE_DIGITAL;
	PORT_InitStructure.PORT_SPEED = PORT_SPEED_MAXFAST;
	
	//    - TxD, RW
	PORT_InitStructure.PORT_OE = PORT_OE_OUT;		
	PORT_InitStructure.PORT_Pin = PORT_Pin_0;
	PORT_Init(MDR_PORTC, &PORT_InitStructure);
	
	PORT_InitStructure.PORT_OE = PORT_OE_OUT;		
	PORT_InitStructure.PORT_Pin = PORT_Pin_2;
	PORT_Init(MDR_PORTC, &PORT_InitStructure);
	rs485_TransmitterCtrl(1); //  	
		
	//    - RxD
	PORT_InitStructure.PORT_OE = PORT_OE_IN;		
	PORT_InitStructure.PORT_Pin = PORT_Pin_1;	
	PORT_Init(MDR_PORTC, &PORT_InitStructure);	
	
	TestTimer = itmr_GetTick();
}
void rs485_DeInit(void)
{
	PORT_DeInit(MDR_PORTC);
}

void rs485_TestWork(char* write_res, char* read_res)
{
	static char flag = 0;
	
	if(itmr_IsTime(TestTimer, TEST_PERIOD)){
		if(flag){			
			PORT_WriteBit(MDR_PORTC, PORT_Pin_0, Bit_SET);	// TxD 1			
			flag = 0;
		}
		else{			
			PORT_WriteBit(MDR_PORTC, PORT_Pin_0, Bit_RESET);	// TxD 0			
			flag = 1;			
		}			
		TestTimer = itmr_GetTick();		
	}
	*write_res = flag; 
	*read_res = PORT_ReadInputDataBit(MDR_PORTC, PORT_Pin_1);		//RX
}
