//#include "MDR1986VE1T.h"

#include "main.h"

#include "MDR32F9Qx_rst_clk.h"
#include "MDR32F9Qx_port.h"
#include "MDR32F9Qx_timer.h"

//#include "MDR1986VE92QI_IT.h"

#include "timcap.h"

void timcap1_Init(void)
{	
	// 
	PORT_InitTypeDef PORT_InitStructure;
	
	TIMER_CntInitTypeDef sTIM_CntInit;	
	TIMER_ChnInitTypeDef ChnInitStruct;	
	RST_CLK_PCLKcmd(RST_CLK_PCLK_RST_CLK | RST_CLK_PCLK_PORTA | RST_CLK_PCLK_TIMER1, ENABLE);

	PORT_InitStructure.PORT_OE = PORT_OE_IN;
	PORT_InitStructure.PORT_PULL_UP = PORT_PULL_UP_ON;
	PORT_InitStructure.PORT_PULL_DOWN = PORT_PULL_DOWN_OFF;
	PORT_InitStructure.PORT_FUNC = PORT_FUNC_MAIN;
	PORT_InitStructure.PORT_MODE = PORT_MODE_DIGITAL;
	PORT_InitStructure.PORT_SPEED = PORT_SPEED_MAXFAST;
	
	PORT_InitStructure.PORT_Pin = PORT_Pin_0;	
	PORT_Init(MDR_PORTA, &PORT_InitStructure);	
	
	// 
	TIMER_BRGInit(MDR_TIMER1, TIMER_HCLKdiv8);	
	sTIM_CntInit.TIMER_IniCounter = 0;
	sTIM_CntInit.TIMER_Prescaler = 0;
	sTIM_CntInit.TIMER_Period = 0xFFFF;
	sTIM_CntInit.TIMER_CounterDirection = TIMER_CntDir_Up;
	sTIM_CntInit.TIMER_CounterMode = TIMER_CntMode_ClkFixedDir;
	sTIM_CntInit.TIMER_EventSource = TIMER_EvSrc_CH1;
	sTIM_CntInit.TIMER_ARR_UpdateMode           = TIMER_ARR_Update_Immediately;
  //sTIM_CntInit.TIMER_ETR_FilterConf           = TIMER_Filter_8FF_at_FTDS_div_32;
  //sTIM_CntInit.TIMER_ETR_Prescaler            = TIMER_ETR_Prescaler_div_2;
	//sTIM_CntInit.TIMER_ETR_Polarity             = TIMER_ETRPolarity_NonInverted;
  //sTIM_CntInit.TIMER_BRK_Polarity             = TIMER_BRKPolarity_NonInverted;
	TIMER_CntInit(MDR_TIMER1, &sTIM_CntInit);
		
	TIMER_ChnStructInit(&ChnInitStruct);	
	ChnInitStruct.TIMER_CH_Number = TIMER_CHANNEL1; 
	ChnInitStruct.TIMER_CH_Mode = TIMER_CH_MODE_CAPTURE;
	ChnInitStruct.TIMER_CH_EventSource = TIMER_CH_EvSrc_NE;
	TIMER_ChnInit(MDR_TIMER1, &ChnInitStruct);

	TIMER_ITConfig(MDR_TIMER1, TIMER_STATUS_CCR_CAP_CH1, ENABLE);	
	NVIC_SetPriority(TIMER1_IRQn, 0);
	NVIC_EnableIRQ(TIMER1_IRQn);
	
	TIMER_Cmd(MDR_TIMER1, ENABLE);	
}

void timcap1_DeInit(void)
{
	TIMER_ITConfig(MDR_TIMER1, TIMER_STATUS_CCR_CAP_CH1, DISABLE);
	NVIC_DisableIRQ(TIMER1_IRQn);
	TIMER_Cmd(MDR_TIMER1, DISABLE);	
}


void timcap2_Init(void)
{	TIMER_CntInitTypeDef sTIM_CntInit;
	RST_CLK_PCLKcmd(RST_CLK_PCLK_RST_CLK | RST_CLK_PCLK_TIMER1, ENABLE);	
	
	
  /* Reset all TIMER1 settings */
  TIMER_DeInit(MDR_TIMER1);

  TIMER_BRGInit(MDR_TIMER1,TIMER_HCLKdiv1);

  /* TIM1 configuration ------------------------------------------------*/
  /* Initializes the TIMERx Counter ------------------------------------*/
  sTIM_CntInit.TIMER_Prescaler                = 4;		//64
  sTIM_CntInit.TIMER_Period                   = 400;	//1000
  sTIM_CntInit.TIMER_CounterMode              = TIMER_CntMode_ClkFixedDir;
  sTIM_CntInit.TIMER_CounterDirection         = TIMER_CntDir_Up;
  sTIM_CntInit.TIMER_EventSource              = TIMER_EvSrc_None;
  sTIM_CntInit.TIMER_FilterSampling           = TIMER_FDTS_TIMER_CLK_div_1;
  sTIM_CntInit.TIMER_ARR_UpdateMode           = TIMER_ARR_Update_Immediately;
  sTIM_CntInit.TIMER_ETR_FilterConf           = TIMER_Filter_1FF_at_TIMER_CLK;
  sTIM_CntInit.TIMER_ETR_Prescaler            = TIMER_ETR_Prescaler_None;
  sTIM_CntInit.TIMER_ETR_Polarity             = TIMER_ETRPolarity_NonInverted;
  sTIM_CntInit.TIMER_BRK_Polarity             = TIMER_BRKPolarity_NonInverted;
	TIMER_CntInit (MDR_TIMER1,&sTIM_CntInit);
	
	TIMER_ITConfig(MDR_TIMER1, TIMER_STATUS_CNT_ARR, ENABLE);	
	NVIC_SetPriority(TIMER1_IRQn, 0);
	NVIC_EnableIRQ(TIMER1_IRQn);
	
	TIMER_Cmd(MDR_TIMER1, ENABLE);
	
}

void timcap2_DeInit(void)
{
	TIMER_ITConfig(MDR_TIMER1, TIMER_STATUS_CNT_ARR, DISABLE);
	NVIC_DisableIRQ(TIMER1_IRQn);
	TIMER_Cmd(MDR_TIMER1, DISABLE);	
}
/*
void timcap4_Init(void)
{	
	// 
	PORT_InitTypeDef PORT_InitStructure;
	
	TIMER_CntInitTypeDef sTIM_CntInit;	
	TIMER_ChnInitTypeDef ChnInitStruct;	
	RST_CLK_PCLKcmd(RST_CLK_PCLK_RST_CLK | RST_CLK_PCLK_PORTA | RST_CLK_PCLK_TIMER4, ENABLE);

	PORT_InitStructure.PORT_OE = PORT_OE_IN;
	PORT_InitStructure.PORT_FUNC = PORT_FUNC_ALTER;
	PORT_InitStructure.PORT_PULL_DOWN = PORT_PULL_DOWN_ON;
	PORT_InitStructure.PORT_MODE = PORT_MODE_DIGITAL;
	PORT_InitStructure.PORT_SPEED = PORT_SPEED_SLOW;
	
	PORT_InitStructure.PORT_Pin = PORT_Pin_10;	
	PORT_Init(MDR_PORTA, &PORT_InitStructure);	
	
	// 
	TIMER_BRGInit(MDR_TIMER4, TIMER_HCLKdiv1);	
	sTIM_CntInit.TIMER_IniCounter = 0;
	sTIM_CntInit.TIMER_Prescaler = 0;
	sTIM_CntInit.TIMER_Period = 0xFF;
	sTIM_CntInit.TIMER_CounterDirection = TIMER_CntDir_Up;
	sTIM_CntInit.TIMER_CounterMode = TIMER_CntMode_ClkFixedDir;
	sTIM_CntInit.TIMER_EventSource = TIMER_EvSrc_None;
	TIMER_CntInit(MDR_TIMER4, &sTIM_CntInit);
	
	TIMER_ChnStructInit(&ChnInitStruct);	
	ChnInitStruct.TIMER_CH_Number = TIMER_CHANNEL3; 
	ChnInitStruct.TIMER_CH_Mode = TIMER_CH_MODE_CAPTURE;
	ChnInitStruct.TIMER_CH_EventSource = TIMER_CH_EvSrc_NE;
	TIMER_ChnInit(MDR_TIMER4, &ChnInitStruct);

	TIMER_ITConfig(MDR_TIMER4, TIMER_STATUS_CCR_CAP_CH3, ENABLE);	
	NVIC_SetPriority(TIMER4_IRQn, 0);
	NVIC_EnableIRQ(TIMER4_IRQn);
	
	TIMER_Cmd(MDR_TIMER4, ENABLE);	
}

void timcap4_DeInit(void)
{
	TIMER_ITConfig(MDR_TIMER4, TIMER_STATUS_CCR_CAP_CH3, DISABLE);	
	NVIC_DisableIRQ(TIMER4_IRQn);
	TIMER_Cmd(MDR_TIMER4, DISABLE);	
}
*/
