#include <stdio.h>
#include <string.h>
#include "itmr.h"
#include "disp.h"
#include "console.h"
#include "wnds.h"
#include "keyboard.h"
#include "button.h"
#include "encoder.h"
#include "main.h"

#include "uart.h"

static char EncStr[12];
static unsigned int PrevData;
static unsigned int CurLevel, PrevLevel;

static bool EventProc(unsigned int code, unsigned int data);

static TWnd Wnd = { WID_ENC, 0, EventProc, 0 };

static bool EventProc(unsigned int code, unsigned int data)
{
  int ch;	
	switch (code) {
    case WE_DRAW:
      if (data == 0) {
				disp_ShowStr(0, 0, "          ");
				disp_ShowStr(0, 1, "          ");
      } 
      break;
		case WE_BUTTON:
			switch(data){
				case LEFT:
					console_CloseWnd(0);
					break;
				default:
					break;
			}
			break;
					
		case WE_KEYS:		
			switch(data){
				case KEY_ESC:
					console_CloseWnd(0);
					break;				
			}
			break;				
		case WE_ENCODER:											
			if(PrevData != data){
				/*PrevLevel = (PrevData * disp_XSize())/encoder_GetMax();
				PrevData = data;
				CurLevel = (PrevData * disp_XSize())/encoder_GetMax();								
				*/
				
				PrevLevel = (PrevData * disp_XSize()/19);
				PrevData = data;
				CurLevel = (PrevData * disp_XSize()/19);								
				
				
				if(PrevLevel < CurLevel){					
					for(ch = PrevLevel; ch < CurLevel; ch++){						
						disp_ShowChar(ch, 3/*disp_YSize() >> 1*/, 'X');
					}
				}
				else{
					if(PrevLevel > CurLevel){						
						for(ch = PrevLevel; ch > CurLevel; ch--){	
							ch--;							
							disp_ShowChar(ch, 3/*disp_YSize() >> 1*/, '  ');
						}
					}				
				}
				
				sprintf(EncStr, "val: %d", CurLevel);
				disp_ShowStr(0, 2, EncStr);
				if(!CurLevel)
					disp_ShowChar(0, 3/*disp_YSize() >> 1*/, ' ');
				
			}			
		
			break;
  }

  return true;
}

void wnd_Enc(void)
{ wnd_choose = 1;
  encoder_Init();
	console_OpenWnd(&Wnd);
}
