#include <string.h>
#include "itmr.h"
#include "console.h"
#include "wnds.h"
#include "eth_drv.h"

static TEthSettings EthSettings;

static TWENumEdit neGATEWAY1 = { 0, 0, 255, 3 };
static TWENumEdit neGATEWAY2 = { 0, 0, 255, 3 };
static TWENumEdit neGATEWAY3 = { 0, 0, 255, 3 };
static TWENumEdit neGATEWAY4 = { 0, 0, 255, 3 };

BEGIN_WE_TABLE(ElemTable)
	DEFINE_WE(WET_NUM_EDIT,	0, 0, 0, "GATEWAY1: ", &neGATEWAY1)
	DEFINE_WE(WET_NUM_EDIT, 0, 1, 0, "GATEWAY2: ", &neGATEWAY2)  	
	DEFINE_WE(WET_NUM_EDIT, 0, 2, 0, "GATEWAY3: ", &neGATEWAY3)  
	DEFINE_WE(WET_NUM_EDIT, 0, 3, 0, "GATEWAY4: ", &neGATEWAY4)  	 
END_WE_TABLE()

static bool EventProc(unsigned int code, unsigned int data);

static TWnd Wnd = { WID_ETH_GATEWAY, ElemTable, EventProc, 0 };

static bool EventProc(unsigned int code, unsigned int data)
{
  switch (code) {
    case WE_DRAW:
      if (data == 0) {
				NumEdit_SetVal(&neGATEWAY1, EthSettings.gateway[0]);
				NumEdit_SetVal(&neGATEWAY2, EthSettings.gateway[1]);
				NumEdit_SetVal(&neGATEWAY3, EthSettings.gateway[2]);
				NumEdit_SetVal(&neGATEWAY4, EthSettings.gateway[3]);	
      }
      break;
		case WE_EDIT_END:
			switch(Wnd.cur_elem){
				case 0:
					EthSettings.gateway[0] = neGATEWAY1.cur_val;
					break;
				case 1:
					EthSettings.gateway[1] = neGATEWAY2.cur_val;
					break;
				case 2:
					EthSettings.gateway[2] = neGATEWAY3.cur_val;
					break;
				case 3:
					EthSettings.gateway[3] = neGATEWAY4.cur_val;
					break;				
			}
			ethernet_SetSettings(&EthSettings);
			break;
  }

  return false;
}

void wnd_EthGATEWAY(void)
{ 
	ethernet_GetSettings(&EthSettings);
  console_OpenWnd(&Wnd);
}
