#include <string.h>
#include "itmr.h"
#include "console.h"
#include "wnds.h"
#include "eth_drv.h"

static TEthSettings EthSettings;

static TWENumEdit neMAC1 = { 0, 0, 255, 3 };
static TWENumEdit neMAC2 = { 0, 0, 255, 3 };
static TWENumEdit neMAC3 = { 0, 0, 255, 3 };
static TWENumEdit neMAC4 = { 0, 0, 255, 3 };
static TWENumEdit neMAC5 = { 0, 0, 255, 3 };
static TWENumEdit neMAC6 = { 0, 0, 255, 3 };

BEGIN_WE_TABLE(ElemTable)
	DEFINE_WE(WET_NUM_EDIT,	0, 0, 0, "MAC1: ", &neMAC1)
	DEFINE_WE(WET_NUM_EDIT, 0, 1, 0, "MAC2: ", &neMAC2)  	
	DEFINE_WE(WET_NUM_EDIT, 0, 2, 0, "MAC3: ", &neMAC3)  
	DEFINE_WE(WET_NUM_EDIT, 0, 3, 0, "MAC4: ", &neMAC4)  
	DEFINE_WE(WET_NUM_EDIT, 0, 4, 0, "MAC5: ", &neMAC5)  
	DEFINE_WE(WET_NUM_EDIT, 0, 5, 0, "MAC6: ", &neMAC6)		  
END_WE_TABLE()

static bool EventProc(unsigned int code, unsigned int data);

static TWnd Wnd = { WID_ETH_MAC, ElemTable, EventProc, 0 };

static bool EventProc(unsigned int code, unsigned int data)
{
  switch (code) {
    case WE_DRAW:
      if (data == 0) {
				NumEdit_SetVal(&neMAC1, EthSettings.mac[0]);
				NumEdit_SetVal(&neMAC2, EthSettings.mac[1]);
				NumEdit_SetVal(&neMAC3, EthSettings.mac[2]);
				NumEdit_SetVal(&neMAC4, EthSettings.mac[3]);
				NumEdit_SetVal(&neMAC5, EthSettings.mac[4]);
				NumEdit_SetVal(&neMAC6, EthSettings.mac[5]);
      }
      break;
		case WE_EDIT_END:
			switch(Wnd.cur_elem){
				case 0:
					EthSettings.mac[0] = neMAC1.cur_val;
					break;
				case 1:
					EthSettings.mac[1] = neMAC2.cur_val;
					break;
				case 2:
					EthSettings.mac[2] = neMAC3.cur_val;
					break;
				case 3:
					EthSettings.mac[3] = neMAC4.cur_val;
					break;
				case 4:
					EthSettings.mac[4] = neMAC5.cur_val;
					break;
				case 5:
					EthSettings.mac[5] = neMAC6.cur_val;
					break;
			}
			ethernet_SetSettings(&EthSettings);
			break;
  }

  return false;
}

void wnd_EthMAC(void)
{ 
	ethernet_GetSettings(&EthSettings);
  console_OpenWnd(&Wnd);
}
